###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.examples module of the BEAT platform.         #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

import numpy
import bob.ip.base


class Algorithm:

    def __init__(self):
        self.block_size = 12
        self.block_overlap = 11
        self.number_of_components = 45


    def setup(self, parameters):
        self.block_size = parameters.get('block-size', self.block_size)
        self.block_overlap = parameters.get('block-overlap', self.block_overlap)
        self.number_of_components = parameters.get('number-of-components',
                                                   self.number_of_components)

        self.extractor = bob.ip.base.DCTFeatures(
            int(self.block_size),
            int(self.block_size),
            int(self.block_overlap),
            int(self.block_overlap),
            int(self.number_of_components),
        )

        return True


    def process(self, inputs, outputs):
        float_image = inputs["image"].data.value

        outputs["features"].write({
            'value': numpy.vstack(self.extractor(float_image))
        })

        return True
