###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.examples module of the BEAT platform.         #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

import numpy

class Algorithm:

    def __init__(self):
        self.data = []
        self.labels = []

    def process(self, inputs, outputs):

        training_set_real = None

        while inputs.hasMoreData():
          inputs['feature_vectors'].next()
          inputs['labels'].next()

          if inputs['labels'].data.text == 'real':
            sample = inputs['feature_vectors'].data.value
            if training_set_real == None:
              training_set_real = numpy.zeros((0, len(sample)), dtype='float64')
            else:
              training_set_real = numpy.vstack([training_set_real, sample])

        model_hist_real = numpy.mean(training_set_real, axis=0) # sum the histograms of the real access videos

        outputs["model_hist"].write({'value': model_hist_real})

        return True
