###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.examples module of the BEAT platform.         #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

import numpy
import bob.learn.linear


class Algorithm:

    def __init__(self):
        self.data = []


    def setup(self, parameters):
        self.number_of_components = parameters['number-of-components']
        return True


    def process(self, inputs, outputs):
        self.data.append(inputs["image"].data.value.astype('float64').flatten())

        if not(inputs.hasMoreData()):
            self.data = numpy.vstack(self.data)

            trainer = bob.learn.linear.PCATrainer()

            pca_machine, eigen_values = trainer.train(self.data)

            pca_machine.resize(pca_machine.shape[0], int(self.number_of_components))

            # outputs data
            outputs["subspace"].write({
                'input_subtract': pca_machine.input_subtract,
                'input_divide':   pca_machine.input_divide,
                'weights':        pca_machine.weights,
                'biases':         pca_machine.biases,
            })

        return True
