###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.examples module of the BEAT platform.         #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

import random
import numpy

class Algorithm:

    def __init__(self):
        self.data = []

    def process(self, inputs, output):
        self.data.append(inputs['in_data'].data.value)

        n_points = 50
        random.seed(0)
        mytable = []
        x = []
        y = []
        for val in range(n_points):
            x.append(float(val) / 10.)
            y.append(float(val % 10) + random.gauss(0,0.5))

            mytable.append({
                'x': float(val) / 10.,
                'y': float(val % 10) + random.gauss(0,0.5),
            })

        if not inputs.hasMoreData():
            output.write({
                'out_data': numpy.float32(sum(self.data)/float(len(self.data))),
                'plot': {"data": [
                                   {
                                     "label": "scatter",
                                     "x": x,
                                     "y": y,
                                    }
                                 ]
                        }
            })

        return True
